/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: extern.h 433 2005-07-26 16:58:24Z drstein $
 *
 */

#ifndef EXTERN_H
#define EXTERN_H

#ifndef _WIN32
#define E extern
#else
#ifdef __CYGWIN__ 
#define E extern
#else
#ifndef MODULE_COMPILE
#define E extern __declspec(dllexport)
#else
#define E extern __declspec(dllimport)
#endif
#endif
#endif


/* IRC Variables */
E IRCDVar *ircd;
E IRCDCAPAB *ircdcap;
E STATVar stats[];
E DenoraVar denora[];

E void initIrcdProto(void);

E int UseTSMODE;
E unsigned long umodes[128];
E char csmodes[128];
E CMMode cmmodes[128];
E CBMode cbmodes[128];
E CBModeInfo *cbmodeinfos;
E CUMode cumodes[128];
E char *normalizeBuffer(char *);
E char *IRCDModule;
E int UseZIP;


/**** channels.c ****/

E Channel *chanlist[1024];
E ChannelStats *cslists[1024];
E StatsChannel *statschanlist[1024];

E void add_ban(Channel * chan, char *mask);
E void chan_adduser2(User * user, Channel * c);
E void add_invite(Channel * chan, char *mask);
E void chan_delete(Channel * c);
E void del_ban(Channel * chan, char *mask);
E void set_key(Channel * chan, char *value);
E void set_limit(Channel * chan, char *value);
E void del_invite(Channel * chan, char *mask);
E char *get_key(Channel * chan);
E char *get_limit(Channel * chan);
E Channel *chan_create(char *chan);
E Channel *join_user_update(User * user, Channel * chan, char *name);
E void add_exception(Channel * chan, char *mask);
E void del_exception(Channel * chan, char *mask);
E char *get_flood(Channel * chan);
E void set_flood(Channel * chan, char *value);
E char *get_redirect(Channel * chan);
E void set_redirect(Channel * chan, char *value);

E StatsChannel *statschan_create(char *chan);
E StatsChannel *findstatschan(const char *chan);
E StatsChannel *next_statschan(void);
E StatsChannel *first_statschan(void);

E Exclude *next_exclude(void);
E Exclude *first_exclude(void);
E Exclude *exlists[1024];

E void post_config_check(void);

E void load_exclude_db(void);
E void save_exclude_db(void);

E void save_stats_db(void);
E void load_stats_db(void);

E void load_chan_db(void);
E void save_chan_db(void);
E ChannelStats *makecs(char *mask);
E int del_cs(ChannelStats * cs);

E Channel *findchan(const char *chan);
E Channel *firstchan(void);
E Channel *nextchan(void);
E void chan_deluser(User * user, Channel * c);
E char *chan_get_modes(Channel * chan, int complete, int plus);
E void chan_set_modes(Channel * chan, int ac, char **av);

E void chan_remove_user_status(Channel * chan, User * user, int16 status);
E void chan_set_user_status(Channel * chan, User * user, int16 status);

E void do_cmode(const char *source, int ac, char **av);
E void do_join(const char *source, int ac, char **av);
E void do_p10_burst(int ac, char **av);
E void do_bmask(char **av);
E void do_kick(const char *source, int ac, char **av);
E void do_p10_kick(const char *source, int ac, char **av);
E void do_part(const char *source, int ac, char **av);
E void do_sjoin(const char *source, int ac, char **av);
E void do_topic(int ac, char **av);

/**** chanstats.c ***/

E void do_cstats(User *u, char *receiver, char *msg);
E void cstats_cron(time_t ts);
E void sumuser(User *u, char *user1, char *user2);
E int get_hour(void);
E User *finduser_by_sgroup(char *nick, char *sgroup);

/**** compat.c ****/

#if !HAVE_SNPRINTF
# if BAD_SNPRINTF
#  define snprintf my_snprintf
# endif
# define vsnprintf my_vsnprintf
E int vsnprintf(char *buf, size_t size, const char *fmt, va_list args);
E int snprintf(char *buf, size_t size, const char *fmt, ...);
#endif
#ifndef HAVE_STRICMP
#ifndef HAVE_STRCASECMP
E int stricmp(const char *s1, const char *s2);
E int strnicmp(const char *s1, const char *s2, size_t len);
#endif
#endif
#if !HAVE_STRDUP
E char *strdup(const char *s);
#endif
char *sstrndup(const char *s, size_t n);
#if !HAVE_STRSPN
E size_t strspn(const char *s, const char *accept);
#endif
#if !HAVE_STRERROR
E char *strerror(int errnum);
#endif
#if !HAVE_STRSIGNAL
E char *strsignal(int signum);
#endif
E unsigned char char_atribs[];

#ifdef _WIN32
E int gettimeofday(struct timeval * tp, struct timezone * tzp);
#endif

E void denora_cron(time_t ts);
E void setup_cron_event(void);
E void cron_process_events(const char *name);
E int destroyCronEvent(CronEvent * evh);
E int addCoreCronEvent(CronEventHash * hookEvtTable[], CronEvent * evh);
E int chanstats_month(const char *name);
E int chanstats_weekly(const char *name);
E int chanstats_daily(const char *name);
E int users_hourly(const char *name);
E int chans_hourly(const char *name);
E int servers_hourly(const char *name);

/**** config.c ****/

E aAdmin *new_admins;
E aAdmin *admins;
E Conf_Modules *new_modules;
E Conf_Modules *modules;
E aAdmin *find_admin(char * name, User * u);
E aAdmin *find_admin_byname(char *name);
E aAdmin *make_admin(void);
E void free_admin(aAdmin * ptr);
E void merge_confs(void);
E void clear_newconfs(void);
E void confparse_error(const char *str, int lnum);

E int is_valid_server(char *name, int num);

E char *RemoteServer;
E int   RemotePort;
E char *RemotePassword;

E char *ExcludeServer;

E char *LocalHost;
E int   LocalPort;

E char *ServerName;
E char *ServerDesc;
E char *ServiceUser;
E char *ServiceHost;

E char *LogChannel;
E char *Smiley;
E char *NetworkName;

E char *s_StatServ;
E char *desc_StatServ;

E char *s_StatServ_alias;
E char *desc_StatServ_alias;

E char *PIDFilename;
E char *MOTDFilename;
E char *OperDBName;
E char *HTMLFilename;

E int KeepBackups;
E int KeepBackupsFor;
E int NoBackupOkay;
E int ReadTimeout;
E int WarningTimeout;
E int UpdateTimeout;
E int BackupFreq;
E int HTMLTimeout;
E int UptimeTimeout;
E int PingFrequency;
E int SQLPingFreq;
E int ClearInActive;
E int ClearChanInActive;
E int 	 UserCacheTime;
E int   UserCleanFreq;
E int   ServerCacheTime;
E int   ServerCleanFreq;
E int   KeepLogs;
E int   DumpCore;
E int   UseTokens;
E int   UseTS6;
E char *Numeric;
E int LargeNet;
E char *TS6SID;
E char p10id[3];
E char *TS6UPLINK;
E char *uplink;
E char *NickChar;
E int CTCPUsers;
E int SP_HTML;

E int   StatsLanguage;
E int   HideStatsO;

E int ModulesNumber;
E int ModulesDelayedNumber;

E int HidePasswords;
E char *UserTable;
E char *ChanBansTable;
E char *ChanExceptTable;
E char *IsOnTable;
E char *ServerTable;
E char *GlineTable;
E char *ChanTable;
E char *MaxValueTable;
E char *ChanInviteTable;
E char *CTCPTable;
E char *TLDTable;
E char *SglineTable;
E char *SqlineTable;
E char *AliasesTable;
E char *CStatsTable;
E char *UStatsTable;
E char *StatsTable;
E char *SpamTable;
E char *CurrentTable;
E char *ChanStatsTable;
E char *ServerStatsTable;

E char *ChannelDB;
E char *ctcpDB;
E char *ServerDB;
E char *ChannelStatsDB;
E char *TLDDB;
E char *excludeDB;
E char *statsDB;

E int rdb_init(void);
E int rdb_close(void);
E int rdb_clear_table(char *table);
E int rdb_direct_query(char *query);
E char *rdb_error_msg(void);
E char *rdb_errmsg;

E char *SqlHost;
E char *SqlUser;
E char *SqlPass;
E char *SqlName;
E int SqlPort;
E char *SqlSock;
E int SqlRetries;
E int SqlRetryGap;
E int sqltype;
E int CSDefFlag;

E int AutoOp;

/**** confparse.c ****/

E int initconf(const char *filename, int reload);

/**** main.c ****/

E void introduce_user(const char *user);
E int init(int ac, char **av);
E void remove_pidfile(void);

E char **langtexts[NUM_LANGS];
E char *langnames[NUM_LANGS];
E int langlist[NUM_LANGS];
E void lang_init(void);
#define getstring(u,index) (langtexts[((u)&&((User*)u)->language?((User*)u)->language:StatsLanguage)][(index)])
#define getstring2(index) (langtexts[(StatsLanguage)][(index)])
E int strftime_lang(char *buf, int size, User * u, int format, struct tm *tm);
E void syntax_error(char *service, User * u, const char *command, int msgnum);
#define langstring(index) (langtexts[(StatsLanguage)][(index)])
#define langstr(index) (langtexts[(StatsLanguage)][(index)])

E int open_log(void);
E void close_log(void);
E void alog(int type, const char *fmt, ...);
E void log_perror(const char *fmt, ...)		FORMAT(printf,1,2);
E void fatal(const char *fmt, ...)		FORMAT(printf,1,2);
E void fatal_perror(const char *fmt, ...)	FORMAT(printf,1,2);

E char  inbuf[BUFSIZE];
E int   servsock;
E int 	waiting;
E int   started;

E void denora_shutdown(void);
E void denora_restart(void);

E void *smalloc(long size);
E void *scalloc(long elsize, long els);
E void *srealloc(void *oldptr, long newsize);
E char *sstrdup(const char *s);
E void strtolwr(char *ch);

E int m_nickcoll(char *user);
E int m_away(char *source, char *msg);
E void m_kill(char *source, char *nick, char *msg);
E int m_motd(char *source);
E int m_privmsg(char *source, char *receiver, char *msg);
E int m_notice(char *source, char *receiver, char *msg);
E int m_stats(char *source, int ac, char **av);
E int m_whois(char *source, char *who);
E int m_time(char *source, int ac, char **av);
E int m_version(char *source, int ac, char **av);

E char *strscpy(char *d, const char *s, size_t len);
E char *stristr(char *s1, char *s2);
E char *strnrepl(char *s, int32 size, const char *old, const char *new);
E char *merge_args(int argc, char **argv);
E void protocol_debug(char *source, int argc, char **argv);
E int match_wild(const char *pattern, const char *str);
E int match_wild_nocase(const char *pattern, const char *str);
E int match_usermask(const char *mask, User * user);
E int dotime(const char *s);

E char *myStrGetToken(const char *str, const char dilim, int token_number);
E char *myStrGetOnlyToken(const char *str, const char dilim, int token_number);
E char *myStrSubString(const char *src, int start, int end);
E char *myStrGetTokenRemainder(const char *str, const char dilim, int token_number);
E int myNumToken(const char *str, const char dilim);
E void doCleanBuffer(char *str);
E int nickIsServices(char *nick);
E void moduleCallBackRun(void);
E void moduleCleanStruct(ModuleData **moduleData);

E void statserv(User *u, char *buf);
E void ss_init(void);

E int is_stats_admin(User *u);
E int split_buf(char *buf, char ***argv);
E void process(void);

E void send_cmd(const char *source, const char *fmt, ...)
	FORMAT(printf,2,3);
E void vsend_cmd(const char *source, const char *fmt, va_list args)
	FORMAT(printf,2,0);

E void notice_server(char *source, Server * s, char *fmt, ...)
	FORMAT(printf,3,4);
E void notice_user(char *source, User *u, const char *fmt, ...)
	FORMAT(printf,3,4);

E void notice_list(char *source, char *dest, char **text);
E void notice_lang(char *source, User *dest, int message, ...);
E void notice_help(char *source, User *dest, int message, ...);


E int new_open_db_read(DenoraDBFile * dbptr, char **key, char **value);
E int new_open_db_write(DenoraDBFile * dbptr);
E void new_close_db(FILE * fptr, char **key, char **value);
E int new_read_db_entry(char **key, char **value, FILE * fptr);
E int new_write_db_entry(const char *key, DenoraDBFile * dbptr, const char *fmt, ...);
E int new_write_db_endofblock(DenoraDBFile * dbptr);
E void fill_db_ptr(DenoraDBFile * dbptr, int version, int core_version, char service[256], char filename[256]);

/**** servers.c ****/

E void count_kicks(User * kicker, User * kicked, Channel * c);
E void count_modes(User * u, Channel * c);
E void count_topics(User * u, Channel * c);

E Server *me_server;
E Server *first_server(void);
E Server *next_server(void);
E ServStats *first_statsserver(void);
E ServStats *next_statserver(void);
E void sql_motd_store(char *source, char *string);

E Server *findserver(const char *name);
E Server *findserver_uid(const char *name);
E ServStats *findserverstats(const char *name);
E void delete_server(Server * serv, const char *quitreason);
E void load_server_db(void);
E void save_server_db(void);

E Server *do_server(const char *source, char *servername, char *hops, char *descript, char *numeric);
E void do_squit(char *servername);
E void capab_parse(int ac, char **av);

E ServStats *make_servstats(const char *server);

/**** sockutil.c ****/

E int32 total_read, total_written;
E int32 total_sendmsg;
E int32 total_recmsg;
E int32 read_buffer_len(void);
E int32 write_buffer_len(void);

E int sgetc(deno_socket_t s);
E char *sgets(char *buf, int len, deno_socket_t s);
E char *sgets2(char *buf, int len, deno_socket_t s);
E int sread(deno_socket_t s, char *buf, int len);
E int sputs(char *str, deno_socket_t s);
E int sockprintf(deno_socket_t s, const char *fmt, ...);
E int conn(const char *host, int port, const char *lhost, int lport);
E void disconn(deno_socket_t s);

E CTCPVerStats *ctcplists[1024];
E void insert_ctcp(CTCPVerStats * c);
E CTCPVerStats *makectcp(char *version);
E int del_ctcpver(CTCPVerStats * c);
E void load_ctcp_db(void);
E void save_ctcp_db(void);
E CTCPVerStats *find_ctcpver(char *version);
E void handle_ctcp_version(char *nick, char *version);
E void sql_do_ctcp(int type, char *version, int count, int overall);
E CTCPVerStats *next_ctcp(void);
E CTCPVerStats *first_ctcp(void);
E void ctcp_update(char *version);

/**** users.c ****/

E User *userlist[1024];
E TLD *tldlist[1024];

E void delete_user(User *user);

E User *finduser(const char *nick);
E User *find_byuid(const char *uid);
E User *first_uid(void);
E User *next_uid(void);
E User *firstuser(void);
E User *nextuser(void);
E Uid *new_uid(const char *nick, char *uid);
E Uid *find_uid(const char *nick);
E Uid *find_nickuid(const char *uid);

E void change_user_host(char *source, char *host);
E void change_user_username(char *source, char *username);
E void change_user_realname(char *source, char *realname);

E User *do_nick(const char *source, char *nick, char *username, char *host,
              char *server, char *realname, time_t ts, uint32 svid, uint32 ip, char *vhost, char *uid, int hopcount, char *modes);

E void do_umode(const char *source, int ac, char **av);
E void do_svsumode(int ac, char **av);
E void do_umode2(const char *source, int ac, char **av);
E void do_quit(const char *source, int ac, char **av);
E void do_kill(char *source, char *reason);

E int is_oper(User * user);
E int has_umode(char *user, int m);
E int has_cmode(char *chan, int m);


#ifdef USE_MYSQL
/**** mysql.c ****/
E MYSQL       *mysql;
E MYSQL_FIELD *mysql_fields;
E MYSQL_ROW   mysql_row;

E int db_mysql_init(void);
E int db_mysql_open(void);
E int db_mysql_close(void);
E int db_mysql_query(char *sql);
E char *db_mysql_quote(char *sql);

#endif

#ifdef USE_POSTGRE
E PGconn *postgre;
E char *db_postgre_quote(char *sql);
#endif

/**** signals.c ****/

E void do_backtrace(int header);
E VOIDSIG sighandler(int signum);
E void signal_init(void);

E void privmsg(char *source, char *dest, const char *fmt, ...);
E void notice(char *source, char *dest, const char *fmt, ...);

/******************************************************************************/


E void denora_cmd_numeric(int numeric, const char *fmt, ...);
E void denora_cmd_219(char *source, char *who); 			  	  		  /* 219 */
E void denora_cmd_318(char *source, char *who);           		  	  		  /* 318 */
E void denora_cmd_351(char *source);				  	  		  /* 351 */
E void denora_cmd_372(char *source, char *msg);			 	  		  /* 372 */
E void denora_cmd_422(char *source);				  	  		  /* 422 */
E void denora_cmd_375(char *source);				 	  		  /* 375 */
E void denora_cmd_376(char *source);				 	  		  /* 376 */
E void denora_cmd_391(char *source, char *timestr);                             		  /* 391 */
E void denora_cmd_401(char *source, char *who);			  	  		  /* 401 */
E void denora_cmd_capab(void);						  	  		  /* CAPAB */
E void denora_cmd_connect(void);                             	           	  /* Connect */
E void denora_cmd_global(char *source, const char *fmt, ...);         	  		  /* GLOBOPS */
E void denora_cmd_join(char *user, char *channel, time_t chantime);   	  		  /* JOIN */
E void denora_cmd_mode(char *source, char *dest, const char *fmt, ...);   	  		  /* MODE */
E void denora_cmd_netinfo(int ac, char **av);						  /* NETINFO */
E void denora_cmd_nick(char *nick, char *name, const char *mode);			  		  /* NICK */
E void denora_cmd_chg_nick(char *oldnick, char *newnick);             	  		  /* NICK */
E void denora_cmd_bot_nick(char *nick, char *user,char *host,char *real,char *modes);	  /* NICK */
E void denora_cmd_notice(char *source, char *dest, const char *fmt, ...);     		  /* NOTICE */
E void denora_cmd_serv_notice(char *source, char *dest, char *msg);		  		  /* NOTICE */
E void denora_cmd_part(char *nick, char *chan, const char *fmt, ...); 	  		  /* PART */
E void denora_cmd_pass(char *pass);                                   	  		  /* PASS */
E void denora_cmd_pong(char *servname, char *who);                    	  		  /* PONG */
E void denora_cmd_privmsg(char *source, char *dest, const char *fmt, ...);    		  /* PRIVMSG */
E void denora_cmd_serv_privmsg(char *source, char *dest, char *msg);	  		  /* PRIVMSG */
E void denora_cmd_protoctl(void);                                         			  /* PROTOCTL */
E void denora_cmd_quit(char *source, const char *fmt, ...);           	  		  /* QUIT */
E void denora_cmd_server(char *servname, int hop, char *descript);    	  		  /* SERVER */
E void denora_cmd_squit(char *servname, char *message);               	  		  /* SQUIT  */
E void denora_cmd_svinfo(void);						  	  		  /* SVINFO */
E void denora_cmd_svsinfo(void);								  /* SVSINFO */
E void denora_cmd_eob(void);									  /* EOB - end of burst */
E void denora_cmd_burst(void);									  /* BURST  - use eob to send burst 0 */
E void denora_cmd_ctcp(char *source, char *dest, const char *fmt, ...);   	  		  /* CTCP */
E void denora_cmd_version(char *server);   	  		  /* VERSION */
E void denora_cmd_stats(char *sender, const char *letter, char *server);  /* STATS */
E void denora_motd(char *sender, char *server);
E void denora_cmd_ping(char *server);
void denora_cmd_notice2(char *source, char *dest, char *msg);
void denora_cmd_privmsg2(char *source, char *dest, char *msg);

E void sql_uline(char *server);

E int denora_event_242(char *source, int ac, char **av);
E int denora_event_246(char *source, int ac, char **av);
E int denora_event_248(char *source, int ac, char **av);
E int denora_event_351(char *source, int ac, char **av);
E int denora_event_482(char *source, int ac, char **av);
E int denora_event_372(char *source, int ac, char **av);
E int denora_event_375(char *source, int ac, char **av);
E int denora_event_376(char *source, int ac, char **av);
E int denora_event_null(char *source, int ac, char **av);

E TLD *tld_sort(void);
E StatsChannel *kick_sort(void);
E CTCPVerStats *ctcp_sort(void);
E StatsChannel *topic_sort(void);
E StatsChannel *top10_sort(void);
E StatsChannel *totaljoin_sort(void);
E void tld_update(char *country_code);

E char *str_signed(unsigned char *str);

E char *common_get_vident(User *u);
E char *common_get_vhost(User *u);
E const char *send_token(const char *token1, const char *token2);

/*
 * base64.c
 */
E char *base64enc(long i);                 /* base64 encode long int   */
E long base64dec(char *b64);               /* base64 decode char       */
E long base64dec_ts(char *ts);             /* base64 decode time stamp */
E char *encode_ip(unsigned char *ip);      /* base64 encode IP address */
E int b64_encode(char *src, size_t srclength, char *target, size_t targsize);
E int b64_decode(char *src, char *target, size_t targsize);
E int decode_ip(char *buf);
E const char *inttobase64(char *buf, unsigned int v, unsigned int count);
E unsigned int base64toIP(char *s);

#define denora_free(x) do { if (x) free(x); (x) = NULL; } while(0)

E void ntoa(struct in_addr addr, char *ipaddr, int len);
E char *militime_float(char* start);
E char *host_resolve(char *host);

E void db_connect(void);
E int rdb_query(const char *fmt, ...);
E char *rdb_escape(char *);
E int db_checkserver(char *serv);
E int db_getserver(char *serv);
E int db_getservfromnick(char *nick);
E int db_checknick(char *nick);
E int db_getnick(char *nick);
E int db_getnick_unsure(char *nick);
E int rdb_insertid(void);
E int db_getchannel(char *chan);
E int db_getchancreate(char *chan);
E void db_removefromchans(int nickid);
E void db_removenick(char *nick);
E void db_checkemptychan(int chanid);
E void db_cleanserver(void);
E void db_cleanuser(void);
E int db_getlusers(int type);
E int db_getchannel_users(char *chan);
E char *db_getchannel_byid(int chanid);

E void do_checkservsmax(void);
E void add_current_user(Server *s);
E void del_current_user(Server *s);
E void do_checkchansmax(void);
E void add_oper_count(User *u);
E void del_oper_count(User *u);

E Exclude *make_exclude(char *mask);
E Exclude *find_exclude(char *mask, char *server);
E void insert_exclude(Exclude * e);
E int del_exclude(Exclude * e);

E void server_store_pong(char *source, uint32 pingtime);
E void ping_servers(void);
E void uptime_servers(void);

E void update_sync_state(char *source, int ac);
E void p10_gline(char *source, char **av);
E void sql_do_sqline(char *mask, char *reason);
E void sql_do_sgline(char *length, char *mask);

E void sql_do_server(char *server, char *hops, char *comment, char *linkedto);
E void sql_do_squit(char *server);
E void sql_do_server_version(char *server, int ac, char **av);
E void sql_do_server_bans_remove(char *type, char *user, char *host);
E void sql_do_server_bans_add(char *type, char *user, char *host, char *setby, char *setat, char *expires, char *reason);
E void sql_do_server_spam_add(char *target, char *action,
                            char *setby, char *expires, char *setat, char *duration,
                            char *reason, char *regex);
E void sql_do_server_spam_remove(char *target, char *action, char *regex);
E void sql_do_nick(char *nick, char *username, char *host,
                 char *server, char *realname, time_t ts, char *vhost, int hopcount,
                 char *ipchar, const char *country_code, const char *country_name);
E void sql_do_sdesc(char *user, char *msg);
E void server_set_desc(char *server, char *msg);
E void sql_do_swhois(char *user, char *msg);
E void sql_do_nick_chg(char *newnick, char *oldnick);
E void sql_do_addusers(int chanid, char *users);
E void sql_do_sjoin(char *chan, char *users, char **modes, int nbmodes);
E void sql_do_topic(char *chan, char *author, int topictime, char *topic);
E void sql_do_part(char *chan, char *nick);
E void sql_do_partall(char *nick);
E void sql_do_join(char *chan, char *nick);
E void sql_do_usermodes(const char *nick, char *modes);
E void sql_do_chanmodes(char *chan, char **av);
E void denora_set_umode(User * user, int ac, char **av);
E int denora_set_mod_current_buffer(int ac, char **av);
E void do_restart_denora(void);
E void sql_do_uptime(char *source, char *uptime);
E void sql_channel_ban(int type, char *chan, char *mask);
E void sql_channel_exception(int type, char *chan, char *mask);
E void sql_channel_invite(int type, char *chan, char *mask);

E GeoIPRecord * GeoIP_record_by_addr (GeoIP* gi, const char *addr);
E GeoIPRecord * GeoIP_record_by_name (GeoIP* gi, const char *host);
E int GeoIP_record_id_by_addr (GeoIP* gi, const char *addr);
E int GeoIP_init_record_iter (GeoIP* gi);
E int GeoIP_next_record (GeoIP* gi, GeoIPRecord **gir, int *record_iter);
E void GeoIPRecord_delete (GeoIPRecord *gir);
E GeoIPBitReader * GeoIPBitReader_new(const char * filename);
E unsigned long GeoIPBitReader_read(GeoIPBitReader * gibr, short int numBits);

E char *GeoIPDBFileName;
E const char * GeoIPDBDescription[NUM_DB_TYPES];
E const char *GeoIPCountryDBFileName;
E const char GeoIP_country_code[247][3];
E const char GeoIP_country_code3[247][4];
E const char * GeoIP_country_name[247];
E const char GeoIP_country_continent[247][3];

E TLD *do_tld(char *country, char *code);
E TLD *findtld(const char *country);
E TLD *next_tld(void);
E TLD *first_tld(void);
E void load_tld_db(void);
E void save_tld_db(void);
E int users_daily(const char *name);

E void save_databases(void);
E void backup_databases(void);

E char *char_encode(char *s1);
E void xml_export_channels(char *file);
E void xml_export_users(char *file);
E void xml_export_tld(char *file);
E void xml_export_all(char *file);
E void xml_export_stats(char *file);
E void xml_export_servers(char *file);
E void xml_export_ctcp(char *file);

E FILE *new_xml(char *filename);
E void xml_write_header(FILE * ptr);
E void xml_write_footer(FILE * ptr);
E void xml_write_tag(FILE * ptr, const char *tag, char *data);
E char *xml_prepare_tag(char *tag, char *data);
E void xml_write_tag_int(FILE * ptr, const char *tag, long int data);
E void xml_write_block(FILE * ptr, char *block, char *data);
E void xml_write_block_top(FILE * ptr, const char *block);
E void xml_write_block_bottom(FILE * ptr, const char *block);
E void xml_moduleData(FILE * ptr, ModuleData ** md);
E char *xml_encode;
E char *xml_doctype;
E char *xml_header;

E void event_message_process(char *eventbuf);
E void eventprintf(const char *fmt, ...);
E void event_process_hook(const char *name, int argc, char **argv);
E void send_event(const char *name, int argc, ...);

E char segv_location[SEGV_LOCATION_BUFSIZE];

#ifndef _WIN32
#define PRETTY_FUNCTION __PRETTY_FUNCTION__
#else
#define PRETTY_FUNCTION ""
#endif

#define SET_SEGV_LOCATION() \
	segv_location[0]='\0'; \
	snprintf(segv_location,SEGV_LOCATION_BUFSIZE,"File %s Line %d function %s", __FILE__, __LINE__, PRETTY_FUNCTION); 

#define SET_SEGV_LOCATION_EXTRA(debug_text) \
	segv_location[0]='\0'; \
	snprintf(segv_location,SEGV_LOCATION_BUFSIZE,"%s %d %s %s", __FILE__, __LINE__, PRETTY_FUNCTION,(debug_text)); 

E void do_html(void);
E int toupper(char);
E int tolower(char);

E void insert_cs(ChannelStats * cs);
E void load_cs_db(void);
E void save_cs_db(void);
E ChannelStats *find_cs(char *mask);

E int denora_get_oper_mode(void);
E void pmodule_set_mod_current_buffer(void (*func) (int ac, char **av));
E void pmodule_cmd_bot_nick(void (*func) (char *nick, char *user, char *host, char *real, char *modes));
E void pmodule_cmd_mode(void (*func) (char *source, char *dest, char *buf));
E void pmodule_cmd_version(void (*func) (char *server));
E void pmodule_cmd_nick(void (*func) (char *nick, char *name, const char *modes));
E void pmodule_cmd_privmsg(void (*func) (char *source, char *dest, char *buf));
E void pmodule_cmd_serv_notice(void (*func) (char *source, char *dest, char *msg));
E void pmodule_cmd_351(void (*func) (char *source));
E void pmodule_cmd_quit(void (*func) (char *source, char *buf));
E void pmodule_ircd_version(const char *version);
E void pmodule_ircd_cbmodeinfos(CBModeInfo * modeinfos);
E void pmodule_ircd_cumodes(CUMode modes[128]);
E int denora_umode(int m);
E int denora_cmode(int m);
E void pmodule_ircd_umodes(unsigned long modes[128]);
E void pmodule_ircd_cbmodes(CBMode modes[128]);
E void pmodule_ircd_cmmodes(CMMode modes[128]);
E void pmodule_ircd_useTSMode(int use);
E void pmodule_cmd_connect(void (*func) (void));
E void pmodule_ircd_csmodes(char mode[128]);
E void pmodule_ircd_var(IRCDVar * ircdvar);
E void pmodule_irc_var(uint32 mode);
E uint32 denora_get_ircd(void);
E void pmodule_ircd_cap(IRCDCAPAB * cap);
E void pmodule_cmd_ctcp(void (*func) (char *source, char *dest, char *buf));
E void pmodule_cmd_part(void (*func) (char *nick, char *chan, char *buf));
E void pmodule_cmd_eob(void (*func) (void));
E void pmodule_cmd_squit(void (*func) (char *servname, char *message));
E void pmodule_cmd_global(void (*func) (char *source, char *buf));
E void pmodule_cmd_join(void (*func) (char *user, char *channel, time_t chantime));
E void pmodule_cmd_pong(void (*func) (char *servname, char *who));
E void pmodule_cmd_serv_privmsg(void (*func) (char *source, char *dest, char *msg));
E void pmodule_cmd_notice(void (*func) (char *source, char *dest, char *buf));
E void pmodule_oper_umode(int mode);
E void pmodule_cmd_stats(void (*func) (char *sender, const char *letter, char *server));
E void pmodule_cmd_motd(void (*func) (char *sender, char *server));
E void pmodule_cmd_ping(void (*func) (char *server));

E int zip_init(int compressionlevel);
E char *unzip_packet(const char *buffer, int length);
E char *zip_buffer(char *buffer, int *length, int flush);

E int moduleCount(void);
E int protocolModuleLoaded(void);
E void core_modules_init(void);
E int protocol_module_init(void);
E Module *mod_current_module;
E char *mod_current_module_name;
E User *mod_current_user;
E int mod_current_op;
E char *mod_current_buffer;

#ifdef __STRICT_ANSI__
#ifndef fileno
int fileno(FILE *stream);
#endif
#endif

#endif	/* EXTERN_H */
