/* Asuka IRCD functions
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 *
 * $Id: asuka.h 427 2005-07-23 08:40:36Z trystan $
 *
 */

#define IRC_UMODE_h 0x00000002  /* umode +h - set host */
#define IRC_UMODE_i 0x00000004  /* umode +i - Invisible */
#define IRC_UMODE_o 0x00000008  /* umode +o - Oper */
#define IRC_UMODE_r 0x00000010  /* umode +r - account nick */
#define IRC_UMODE_w 0x00000020  /* umode +w - Get wallops */
#define IRC_UMODE_x 0x00000080  /* umode +x - hide */
#define IRC_UMODE_X 0x00000100  /* umode +X - xtra op */
#define IRC_UMODE_O 0x00001000  /* umode +O - Local Oper */
#define IRC_UMODE_s 0x00002000  /* umode +s - Server notices */
#define IRC_UMODE_k 0x00008000  /* umode +k - kicked by services only */
#define IRC_UMODE_d 0x00040000  /* umode +d - deaf */
#define IRC_UMODE_g 0x00080000  /* umode +g - debug */
#define IRC_UMODE_I 0x02000000  /* umode +I - no idle */
#define IRC_UMODE_n 0x40000000  /* umode +n - no chan */
#define IRC_UMODE_R 0x80000000  /* umode +R - account only */


/* ispmtcdCDNu */
#define IRCD_CMODE_i 0x00000001
#define IRCD_CMODE_m 0x00000002
#define IRCD_CMODE_n 0x00000004
#define IRCD_CMODE_p 0x00000008
#define IRCD_CMODE_s 0x00000010
#define IRCD_CMODE_t 0x00000020
#define IRCD_CMODE_k 0x00000040	/* These two used only by ChanServ */
#define IRCD_CMODE_l 0x00000080
#define IRCD_CMODE_r 0x00000200	/* Set for all registered channels */
#define IRCD_CMODE_c 0x00000400	/* Colors can't be used */
#define IRCD_CMODE_C 0x00000800
#define IRCD_CMODE_D 0x00001000
#define IRCD_CMODE_d 0x00002000
#define IRCD_CMODE_N 0x00004000
#define IRCD_CMODE_u 0x00008000


void asuka_cmd_nick(char *nick, char *name, const char *modes);
void asuka_cmd_mode(char *source, char *dest, char *buf);
void asuka_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes);
void asuka_cmd_notice(char *source, char *dest, char *buf);
void asuka_cmd_privmsg(char *source, char *dest, char *buf);
void asuka_cmd_serv_notice(char *source, char *dest, char *msg);
void asuka_cmd_serv_privmsg(char *source, char *dest, char *msg);
void asuka_cmd_351(char *source);
void asuka_cmd_quit(char *source, char *buf);
void asuka_cmd_pong(char *servname, char *who);
void asuka_cmd_join(char *user, char *channel, time_t chantime);
void asuka_cmd_server(char *servname, int hop, char *descript);
void asuka_cmd_part(char *nick, char *chan, char *buf);
void asuka_cmd_global(char *source, char *buf);
void asuka_cmd_squit(char *servname, char *message);
void asuka_cmd_connect(void);
void asuka_cmd_eob(void);
void asuka_cmd_capab(void);
void asuka_cmd_ctcp(char *source, char *dest, char *buf);
void asuka_cmd_pass(char *pass);
void asuka_cmd_version(char *server);
void asuka_cmd_stats(char *sender, const char *letter, char *server);
void asuka_cmd_motd(char *sender, char *server);
void asuka_cmd_ping(char *server);

int denora_event_436(char *source, int ac, char **av);
int denora_event_away(char *source, int ac, char **av);
int denora_event_ping(char *source, int ac, char **av);
int denora_event_motd(char *source, int ac, char **av);
int denora_event_join(char *source, int ac, char **av);
int denora_event_kick(char *source, int ac, char **av);
int denora_event_kill(char *source, int ac, char **av);
int denora_event_mode(char *source, int ac, char **av);
int denora_event_quit(char *source, int ac, char **av);
int denora_event_squit(char *source, int ac, char **av);
int denora_event_topic(char *source, int ac, char **av);
int denora_event_whois(char *source, int ac, char **av);
int denora_event_part(char *source, int ac, char **av);
int denora_event_server(char *source, int ac, char **av);
int denora_event_nick(char *source, int ac, char **av);
int denora_event_gnotice(char *source, int ac, char **av);
int denora_event_privmsg(char *source, int ac, char **av);
int denora_event_sjoin(char *source, int ac, char **av);
int denora_event_eob(char *source, int ac, char **av);
int denora_event_pass(char *source, int ac, char **av);
int denora_event_error(char *source, int ac, char **av);
int denora_event_notice(char *source, int ac, char **av);
int denora_event_globops(char *source, int ac, char **av);
int denora_event_burst(char *source, int ac, char **av);
int denora_event_create(char *source, int ac, char **av);
int denora_event_pong(char *source, int ac, char **av);
int denora_event_sgline(char *source, int ac, char **av);

int DenoraInit(int argc, char **argv);
void moduleAddIRCDMsgs(void);
void moduleAddIRCDCmds(void);
void DenoraFini(void);
