/* DreamForge IRCD functions
 *
 * (C) 2003-2005 Anope Team
 * Contact us at info@anope.org
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Epona by Lara.
 * Based on the original code of Services by Andy Church. 
 * 
 *
 */

#define IRC_UMODE_a 0x00000001  /* Services Admin */ 
#define IRC_UMODE_h 0x00000002  /* Help system operator */
#define IRC_UMODE_i 0x00000004  /* makes user invisible */
#define IRC_UMODE_o 0x00000008  /* Operator */
#define IRC_UMODE_r 0x00000010  /* Nick set by services as registered */
#define IRC_UMODE_w 0x00000020  /* send wallops to them */
#define IRC_UMODE_A 0x00000040  /* Admin */
#define IRC_UMODE_O 0x00000080  /* Local operator */
#define IRC_UMODE_s 0x00000100  /* server notices such as kill */
#define IRC_UMODE_k 0x00000200  /* Show server-kills... */
#define IRC_UMODE_c 0x00000400  /* Show client information */
#define IRC_UMODE_f 0x00000800  /* Receive flood warnings */
#define IRC_UMODE_g 0x80000000  /* Shows some global messages */

#define IRCD_CMODE_i 0x00000001
#define IRCD_CMODE_m 0x00000002
#define IRCD_CMODE_n 0x00000004
#define IRCD_CMODE_p 0x00000008
#define IRCD_CMODE_s 0x00000010
#define IRCD_CMODE_t 0x00000020
#define IRCD_CMODE_k 0x00000040		/* These two used only by ChanServ */
#define IRCD_CMODE_l 0x00000080
#define IRCD_CMODE_R 0x00000100		/* Only identified users can join */
#define IRCD_CMODE_r 0x00000200		/* Set for all registered channels */

void dreamforge_cmd_nick(char *nick, char *name, const char *modes);
void dreamforge_cmd_mode(char *source, char *dest, char *buf);
void dreamforge_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes);
void dreamforge_cmd_kick(char *source, char *chan, char *user, char *buf);
void dreamforge_cmd_notice_ops(char *source, char *dest, char *buf);
void dreamforge_cmd_notice(char *source, char *dest, char *buf);
void dreamforge_cmd_notice2(char *source, char *dest, char *msg);
void dreamforge_cmd_privmsg(char *source, char *dest, char *buf);
void dreamforge_cmd_privmsg2(char *source, char *dest, char *msg);
void dreamforge_cmd_serv_notice(char *source, char *dest, char *msg);
void dreamforge_cmd_serv_privmsg(char *source, char *dest, char *msg);
void dreamforge_cmd_bot_chan_mode(char *nick, char *chan);
void dreamforge_cmd_351(char *source);
void dreamforge_cmd_quit(char *source, char *buf);
void dreamforge_cmd_pong(char *servname, char *who);
void dreamforge_cmd_join(char *user, char *channel, time_t chantime);
void dreamforge_cmd_part(char *nick, char *chan, char *buf);
void dreamforge_cmd_global(char *source, char *buf);
void dreamforge_cmd_squit(char *servname, char *message);
void dreamforge_cmd_connect(void);
void dreamforge_cmd_eob(void);
void dreamforge_cmd_ctcp(char *source, char *dest, char *buf);
void dreamforge_cmd_server(char *servname, int hop, char *descript);
void dreamforge_cmd_pass(char *pass);
void dreamforge_cmd_capab(void);

int denora_event_436(char *source, int ac, char **av);
int denora_event_away(char *source, int ac, char **av);
int denora_event_ping(char *source, int ac, char **av);
int denora_event_motd(char *source, int ac, char **av);
int denora_event_join(char *source, int ac, char **av);
int denora_event_kick(char *source, int ac, char **av);
int denora_event_kill(char *source, int ac, char **av);
int denora_event_mode(char *source, int ac, char **av);
int denora_event_quit(char *source, int ac, char **av);
int denora_event_squit(char *source, int ac, char **av);
int denora_event_topic(char *source, int ac, char **av);
int denora_event_whois(char *source, int ac, char **av);
int denora_event_part(char *source, int ac, char **av);
int denora_event_server(char *source, int ac, char **av);
int denora_event_nick(char *source, int ac, char **av);
int denora_event_privmsg(char *source, int ac, char **av);
int denora_event_capab(char *source, int ac, char **av);
int denora_event_sjoin(char *source, int ac, char **av);
int denora_event_error(char *source, int ac, char **av);
int denora_event_notice(char *source, int ac, char **av);
int denora_event_burst(char *source, int ac, char **av);
int denora_event_sqline(char *source, int ac, char **av);
int denora_event_pong(char *source, int ac, char **av);

int DenoraInit(int argc, char **argv);
void moduleAddIRCDMsgs(void);
void moduleAddIRCDCmds(void);
void DenoraFini(void);
