/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: ptlink.h 427 2005-07-23 08:40:36Z trystan $
 *
 */

#define IRC_UMODE_a 0x00000001
#define IRC_UMODE_h 0x00000002
#define IRC_UMODE_i 0x00000004
#define IRC_UMODE_o 0x00000008
#define IRC_UMODE_r 0x00000010
#define IRC_UMODE_w 0x00000020
#define IRC_UMODE_A 0x00000040
#define IRC_UMODE_B 0x00000080
#define IRC_UMODE_H 0x00000100
#define IRC_UMODE_N 0x00000200
#define IRC_UMODE_O 0x00000400
#define IRC_UMODE_p 0x00000800
#define IRC_UMODE_R 0x00001000
#define IRC_UMODE_s 0x00002000
#define IRC_UMODE_S 0x00004000
#define IRC_UMODE_T 0x00008000
#define IRC_UMODE_v 0x00001000
#define IRC_UMODE_y 0x00002000
#define IRC_UMODE_z 0x00004000

#define IRCD_CMODE_i 0x00000001
#define IRCD_CMODE_m 0x00000002
#define IRCD_CMODE_n 0x00000004
#define IRCD_CMODE_p 0x00000008
#define IRCD_CMODE_s 0x00000010
#define IRCD_CMODE_t 0x00000020
#define IRCD_CMODE_k 0x00000040		/* These two used only by ChanServ */
#define IRCD_CMODE_l 0x00000080
#define IRCD_CMODE_A 0x00000400
#define IRCD_CMODE_B 0x00000800
#define IRCD_CMODE_c 0x00001000
#define IRCD_CMODE_d 0x00002000
#define IRCD_CMODE_f 0x00004000
#define IRCD_CMODE_K 0x00008000
#define IRCD_CMODE_O 0x00010000
#define IRCD_CMODE_q 0x00020000
#define IRCD_CMODE_S 0x00040000
#define IRCD_CMODE_N 0x00080000
#define IRCD_CMODE_R 0x00000100		/* Only identified users can join */
#define IRCD_CMODE_r 0x00000200		/* Set for all registered channels */
#define IRCD_CMODE_C 0x00100000

/*
   The following variables are set to define the TS protocol version
   that we support. 

   PTLink 6.14 to 6.17  TS CURRENT is 6  and MIN is 3
   PTlink 6.18          TS CURRENT is 9  and MIN is 3
   PTLink 6.19 		TS CURRENT is 10 and MIN is 9

   If you are running 6.18 or 6.19 do not touch these values as they will
   allow you to connect

   If you are running an older version of PTLink, first think about updating
   your ircd, or changing the TS_CURRENT to 6 to allow services to connect
*/

#define PTLINK_TS_CURRENT 9
#define PTLINK_TS_MIN 3

void ptlink_cmd_nick(char *nick, char *name, const char *modes);
void ptlink_cmd_mode(char *source, char *dest, char *buf);
void ptlink_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes);
void ptlink_cmd_notice(char *source, char *dest, char *buf);
void ptlink_cmd_privmsg(char *source, char *dest, char *buf);
void ptlink_cmd_serv_notice(char *source, char *dest, char *msg);
void ptlink_cmd_serv_privmsg(char *source, char *dest, char *msg);
void ptlink_cmd_351(char *source);
void ptlink_cmd_quit(char *source, char *buf);
void ptlink_cmd_pong(char *servname, char *who);
void ptlink_cmd_join(char *user, char *channel, time_t chantime);
void ptlink_cmd_part(char *nick, char *chan, char *buf);
void ptlink_cmd_global(char *source, char *buf);
void ptlink_cmd_squit(char *servname, char *message);
void ptlink_cmd_connect(void);
void ptlink_cmd_eob(void);
void ptlink_cmd_ctcp(char *source, char *dest, char *buf);
void ptlink_cmd_version(char *server);
void ptlink_cmd_stats(char *sender, const char *letter, char *server);
void ptlink_cmd_motd(char *sender, char *server);
void ptlink_cmd_ping(char *server);
void ptlink_cmd_pass(char *pass);
void ptlink_cmd_server(char *servname, int hop, char *descript);
void ptlink_cmd_svsinfo(void);
void ptlink_cmd_svinfo(void);
void ptlink_cmd_capab(void);

int denora_event_436(char *source, int ac, char **av);
int denora_event_away(char *source, int ac, char **av);
int denora_event_ping(char *source, int ac, char **av);
int denora_event_motd(char *source, int ac, char **av);
int denora_event_join(char *source, int ac, char **av);
int denora_event_kick(char *source, int ac, char **av);
int denora_event_kill(char *source, int ac, char **av);
int denora_event_mode(char *source, int ac, char **av);
int denora_event_quit(char *source, int ac, char **av);
int denora_event_squit(char *source, int ac, char **av);
int denora_event_topic(char *source, int ac, char **av);
int denora_event_whois(char *source, int ac, char **av);
int denora_event_part(char *source, int ac, char **av);
int denora_event_server(char *source, int ac, char **av);
int denora_event_nick(char *source, int ac, char **av);
int denora_event_gnotice(char *source, int ac, char **av);
int denora_event_privmsg(char *source, int ac, char **av);
int denora_event_capab(char *source, int ac, char **av);
int denora_event_sjoin(char *source, int ac, char **av);
int denora_event_svinfo(char *source, int ac, char **av);
int denora_event_chghost(char *source, int ac, char **av);
int denora_event_sethost(char *source, int ac, char **av);
int denora_event_chgident(char *source, int ac, char **av);
int denora_event_setident(char *source, int ac, char **av);
int denora_event_chgname(char *source, int ac, char **av);
int denora_event_setname(char *source, int ac, char **av);
int denora_event_svsinfo(char *source, int ac, char **av);
int denora_event_snick(char *source, int ac, char **av);
int denora_event_vhost(char *source, int ac, char **av);
int denora_event_tkl(char *source, int ac, char **av);
int denora_event_eos(char *source, int ac, char **av);
int denora_event_eob(char *source, int ac, char **av);
int denora_event_pass(char *source, int ac, char **av);
int denora_event_netinfo(char *source, int ac, char **av);
int denora_event_error(char *source, int ac, char **av);
int denora_event_netctrl(char *source, int ac, char **av);
int denora_event_notice(char *source, int ac, char **av);
int denora_event_snotice(char *source, int ac, char **av);
int denora_event_smo(char *source, int ac, char **av);
int denora_event_myid(char *source, int ac, char **av);
int denora_event_vctrl(char *source, int ac, char **av);
int denora_event_tctrl(char *source, int ac, char **av);
int denora_event_snetinfo(char *source, int ac, char **av);
int denora_event_umode2(char *source, int ac, char **av);
int denora_event_globops(char *source, int ac, char **av);
int denora_event_swhois(char *source, int ac, char **av);
int denora_event_burst(char *source, int ac, char **av);
int denora_event_sdesc(char *source, int ac, char **av);
int denora_event_svsmode(char *source, int ac, char **av);
int denora_event_akill(char *source, int ac, char **av);
int denora_event_rakill(char *source, int ac, char **av);
int denora_event_pong(char *source, int ac, char **av);
int denora_event_newmask(char *source, int ac, char **av);

int DenoraInit(int argc, char **argv);
void moduleAddIRCDMsgs(void);
void moduleAddIRCDCmds(void);
void DenoraFini(void);
