/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: quakeircd.c 433 2005-07-26 16:58:24Z drstein $
 *
 */

/*************************************************************************/

#include "denora.h"
#include "quakeircd.h"

IRCDVar myIrcd[] = {
    {"QuakeIRCD 2.0 Ruby",      /* ircd name */
     "+ioS",                    /* operserv mode */
     1,                         /* Vhost  */
     1,                         /* Supports SGlines     */
     0,                         /* sgline sql table */
     1,                         /* Supports SQlines     */
     0,                         /* sqline sql table */
     1,                         /* Supports SZlines     */
     1,                         /* Has exceptions +e    */
     1,                         /* vidents              */
     0,                         /* NICKIP               */
     1,                         /* VHOST ON NICK        */
     1,                         /* +f                   */
     1,                         /* +L                   */
     IRCD_CMODE_f,                   /* +f Mode                          */
     IRCD_CMODE_L,                   /* +L Mode                          */
     NULL,                      /* CAPAB Chan Modes             */
     1,                         /* We support Unreal TOKENS */
     0,                         /* TOKENS are CASE Sensitive */
     1,                         /* TIME STAMPS are BASE64 */
     1,                         /* +I support */
     '&',                       /* SJOIN ban char */
     '\"',                      /* SJOIN except char */
     IRC_UMODE_x,
     1,
     1,
     1,
     "acdfghiopqrtvwxzABCDEGHINRSTVW",
     "abcefghijklmnoqprstuvyzABCDGHIKLMNOQRSTVXY",
     'f',
     'j',
     'x',
     't',
     0,
     0,
     1, 
     1,
     0,
     'b',
     'e',
     'I',
     0,
     1,
     NULL,
     1},
};

IRCDCAPAB myIrcdcap[] = {
    {
     CAPAB_NOQUIT,              /* NOQUIT       */
     0,                         /* TSMODE       */
     0,                         /* UNCONNECT    */
     CAPAB_NICKIP,              /* NICKIP       */
     0,                         /* SJOIN        */
     CAPAB_ZIP,                 /* ZIP          */
     0,                         /* BURST        */
     0,                         /* TS5          */
     0,                         /* TS3          */
     0,                         /* DKEY         */
     0,                         /* PT4          */
     0,                         /* SCS          */
     0,                         /* QS           */
     0,                         /* UID          */
     0,                         /* KNOCK        */
     0,                         /* CLIENT       */
     0,                         /* IPV6         */
     0,                         /* SSJ5         */
     0,                         /* SN2          */
     CAPAB_TOKEN,               /* TOKEN        */
     0,                         /* VHOST        */
     CAPAB_SSJ3,                /* SSJ3         */
     CAPAB_NICK2,               /* NICK2        */
     CAPAB_UMODE2,              /* UMODE2       */
     CAPAB_VL,                  /* VL           */
     CAPAB_TLKEXT,              /* TLKEXT       */
     0,                         /* DODKEY       */
     0,                         /* DOZIP        */
     CAPAB_CHANMODE,            /* CHANMODE             */
     CAPAB_SJB64,
     0,
     }
};

unsigned long myumodes[128] = {
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused, Unused, Horzontal Tab */
    0, 0, 0,                    /* Line Feed, Unused, Unused */
    0, 0, 0,                    /* Carriage Return, Unused, Unused */
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused, Unused, Space */
    0, 0, 0,                    /* ! " #  */
    0, 0, 0,                    /* $ % &  */
    0, 0, 0,                    /* ! ( )  */
    0, 0, 0,                    /* * + ,  */
    0, 0, 0,                    /* - . /  */
    0, 0,                       /* 0 1 */
    0, 0,                       /* 2 3 */
    0, 0,                       /* 4 5 */
    0, 0,                       /* 6 7 */
    0, 0,                       /* 8 9 */
    0, 0,                       /* : ; */
    0, 0, 0,                    /* < = > */
    0, 0,                       /* ? @ */
    IRC_UMODE_A, IRC_UMODE_B, IRC_UMODE_C,  /* A B C */
    IRC_UMODE_D, 0, 0,              /* D E F */
    IRC_UMODE_G, IRC_UMODE_H, IRC_UMODE_I,  /* G H I */
    0, 0, 0,                    /* J K L */
    0, IRC_UMODE_N, IRC_UMODE_O,        /* M N O */
    0, 0, IRC_UMODE_R,              /* P Q R */
    IRC_UMODE_S, IRC_UMODE_T, 0,        /* S T U */
    IRC_UMODE_V, IRC_UMODE_W, 0,        /* V W X */
    0,                          /* Y */
    0,                          /* Z */
    0, 0, 0,                    /* [ \ ] */
    0, 0, 0,                    /* ^ _ ` */
    IRC_UMODE_a, 0, 0,              /* a b c */
    IRC_UMODE_d, 0, IRC_UMODE_f,        /* d e f */
    IRC_UMODE_g, IRC_UMODE_h, IRC_UMODE_i,  /* g h i */
    0, 0, 0,                    /* j k l */
    0, 0, IRC_UMODE_o,              /* m n o */
    IRC_UMODE_p, IRC_UMODE_q, IRC_UMODE_r,  /* p q r */
    IRC_UMODE_s, IRC_UMODE_t, 0,        /* s t u */
    IRC_UMODE_v, IRC_UMODE_w, IRC_UMODE_x,  /* v w x */
    0,                          /* y */
    IRC_UMODE_z,                    /* z */
    0, 0, 0,                    /* { | } */
    0, 0                        /* ~  */
};

char myCsmodes[128] = {
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

    0,
    'g',
    0, 0, 0,
    'h',                        /* (37) % Channel halfops */
    'b',                        /* (38) & bans */
    0, 0, 0,
    'q',

    'v', 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

    'o', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a', 0
};

CMMode myCmmodes[128] = {
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, 
    {NULL, NULL},                     /* A */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* BCD */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* EFG */
    {NULL, NULL},                     /* H */
    {add_invite, del_invite},   /* I */
    {NULL, NULL},                     /* J */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* KLM */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* NOP */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* QRS */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* TUV */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* WXY */
    {NULL, NULL},                     /* Z */
    {NULL, NULL}, {NULL, NULL},             /* (char 91 - 92) */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* (char 93 - 95) */
    {NULL, NULL},                     /* ` (char 96) */
    {NULL, NULL},                     /* a (char 97) */
    {add_ban, del_ban},         /* b */
    {NULL, NULL}, {NULL, NULL},             /* cd */
    {add_exception, del_exception},
    {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
};

CBMode myCbmodes[128] = {
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0},
    {IRCD_CMODE_A, NULL},            /* A */
    {IRCD_CMODE_B, NULL},            /* B */
    {IRCD_CMODE_C, NULL},            /* C */
    {0, 0},                        /* D */
    {0, 0},                        /* E */
    {0, 0},                        /* F */
    {IRCD_CMODE_G, NULL},            /* G */
    {0, 0},                        /* H */
    {0, 0},                        /* I */
    {0, 0},                        /* J */
    {IRCD_CMODE_K, NULL},            /* K */
    {IRCD_CMODE_L, set_redirect},    /* L */
    {IRCD_CMODE_M, NULL},            /* M */
    {IRCD_CMODE_N, NULL},            /* N */
    {IRCD_CMODE_O, NULL},            /* O */
    {0, 0},                        /* P */
    {IRCD_CMODE_Q, NULL},          /* Q */
    {IRCD_CMODE_R, NULL},          /* R */
    {IRCD_CMODE_S, NULL},          /* S */
    {IRCD_CMODE_T, NULL},          /* T */
    {0, 0},                        /* U */
    {IRCD_CMODE_V, NULL},          /* V */
    {0, 0},                        /* W */
    {IRCD_CMODE_X, NULL},          /* X */
    {IRCD_CMODE_Y, NULL},          /* Y */
    {0, 0},                        /* Z */
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0},                        /* a */
    {0, 0},                        /* b */
    {IRCD_CMODE_c, NULL},            /* c */
    {0, 0},                        /* d */
    {0, 0},                        /* e */
    {IRCD_CMODE_f, set_flood},       /* f */
    {0, 0},                        /* g */
    {0, 0},                        /* h */
    {IRCD_CMODE_i, NULL},            /* i */
    {IRCD_CMODE_i, set_flood},       /* j */
    {IRCD_CMODE_k, set_key},         /* k */
    {IRCD_CMODE_l, set_limit},       /* l */
    {IRCD_CMODE_m, NULL},            /* m */
    {IRCD_CMODE_n, NULL},            /* n */
    {0, 0},                        /* o */
    {IRCD_CMODE_p, NULL},            /* p */
    {0, 0},                        /* q */
    {IRCD_CMODE_r, NULL},            /* r */
    {IRCD_CMODE_s, NULL},            /* s */
    {IRCD_CMODE_t, NULL},            /* t */
    {IRCD_CMODE_u, NULL},            /* u */
    {0, 0},                        /* v */
    {0, 0},                        /* w */
    {0, 0},                        /* x */
    {0, 0},                        /* y */
    {IRCD_CMODE_z, NULL},            /* z */
    {0, 0}, {0, 0}, {0, 0}, {0, 0}
};

CBModeInfo myCbmodeinfos[] = {
    {'c', IRCD_CMODE_c, NULL},
    {'f', IRCD_CMODE_f, get_flood},
    {'i', IRCD_CMODE_i, NULL},
    {'k', IRCD_CMODE_k, get_key},
    {'l', IRCD_CMODE_l, get_limit},
    {'m', IRCD_CMODE_m, NULL},
    {'n', IRCD_CMODE_n, NULL},
    {'p', IRCD_CMODE_p, NULL},
    {'r', IRCD_CMODE_r, NULL},
    {'s', IRCD_CMODE_s, NULL},
    {'t', IRCD_CMODE_t, NULL},
    {'u', IRCD_CMODE_u, NULL},
    {'z', IRCD_CMODE_z, NULL},
    {'A', IRCD_CMODE_A, NULL},
    {'B', IRCD_CMODE_B, NULL},
    {'C', IRCD_CMODE_C, NULL},
    {'G', IRCD_CMODE_G, NULL},
    {'K', IRCD_CMODE_K, NULL},
    {'L', IRCD_CMODE_L, get_redirect},
    {'M', IRCD_CMODE_M, NULL},
    {'N', IRCD_CMODE_N, NULL},
    {'O', IRCD_CMODE_O, NULL},
    {'Q', IRCD_CMODE_Q, NULL},
    {'R', IRCD_CMODE_R, NULL},
    {'S', IRCD_CMODE_S, NULL},
    {'T', IRCD_CMODE_T, NULL},
    {'V', IRCD_CMODE_V, NULL},
    {'X', IRCD_CMODE_X, NULL},
    {'Y', IRCD_CMODE_Y, NULL},
};

void quakeircd_cmd_version(char *server)
{
    send_cmd(s_StatServ, "VERSION %s", server);
}

/* Event: PROTOCTL */
int denora_event_capab(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    capab_parse(ac, av);
    return MOD_CONT;
}

void quakeircd_cmd_nick(char *nick, char *name, const char *modes)
{
    send_cmd(NULL, "%s %s 1 %ld %s %s %s 0 %s %s%s :%s",
             send_token("NICK", "&"), nick, (long int) time(NULL),
             ServiceUser, ServiceHost, ServerName, modes, ServiceHost,
             (ircd->nickip ? " *" : " "), name);
}

void quakeircd_cmd_mode(char *source, char *dest, char *buf)
{
    send_cmd(source, "%s %s %s", send_token("MODE", "G"), dest, buf);
}

void quakeircd_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes)
{
    send_cmd(NULL, "%s %s 1 %ld %s %s %s 0 %s %s%s :%s",
             send_token("NICK", "&"), nick, (long int) time(NULL),
             user, host, ServerName, modes, host,
             (ircd->nickip ? " *" : " "), real);
}

void quakeircd_cmd_notice(char *source, char *dest, char *buf)
{
    send_cmd(source, "%s %s :%s", send_token("NOTICE", "B"), dest, buf);
}

void quakeircd_cmd_privmsg(char *source, char *dest, char *buf)
{
    send_cmd(source, "%s %s :%s", send_token("PRIVMSG", "!"), dest, buf);
}

void quakeircd_cmd_serv_notice(char *source, char *dest, char *msg)
{
    send_cmd(source, "%s $%s :%s", send_token("NOTICE", "B"), dest, msg);
}

void quakeircd_cmd_serv_privmsg(char *source, char *dest, char *msg)
{
    send_cmd(source, "%s $%s :%s", send_token("PRIVMSG", "!"), dest, msg);
}

void quakeircd_cmd_351(char *source)
{
    send_cmd(ServerName,
             "351 %s Denora-%s %s :%s -- build #%s, compiled %s %s",
             source, denora->version, ServerName, ircd->name, denora->build, denora->date, denora->time);
}

void quakeircd_cmd_stats(char *sender, const char *letter, char *server)
{
    send_cmd(sender, "STATS %s %s", letter, server);
}

/* QUIT */
void quakeircd_cmd_quit(char *source, char *buf)
{
    if (buf) {
        send_cmd(source, "%s :%s", send_token("QUIT", ","), buf);
    } else {
        send_cmd(source, "%s", send_token("QUIT", ","));
    }
}

/* PROTOCTL */
/*
   NICKv2 = Nick Version 2
   VHP    = Sends hidden host 
   UMODE2 = sends UMODE2 on user modes
   NICKIP = Sends IP on NICK
   TOKEN  = Use tokens to talk
   SJ3    = Supports SJOIN
   NOQUIT = No Quit
   TKLEXT = Extended TKL we don't use it but best to have it
   SJB64  = Base64 encoded time stamps
   VL     = Version Info
   NS     = Numeric Server

*/
void quakeircd_cmd_capab()
{
    send_cmd(NULL,
             "PROTOCTL NICKv2 VHP UMODE2 NICKIP%sSJOIN SJOIN2 SJ3 NOQUIT TKLEXT SJB64%s",
             (UseTokens ? " TOKEN " : " "), (Numeric ? " VL NS" : " "));
}

/* PASS */
void quakeircd_cmd_pass(char *pass)
{
    send_cmd(NULL, "PASS :%s", pass);
}

/* SERVER name hop descript */
/* Unreal 3.2 actually sends some info about itself in the descript area */
void quakeircd_cmd_server(char *servname, int hop, char *descript)
{
    if (Numeric) {
        send_cmd(NULL, "SERVER %s %d :U0-*-%s %s", servname, hop, Numeric,
                 descript);
    } else {
        send_cmd(NULL, "SERVER %s %d :%s", servname, hop, descript);
    }
}

/* PONG */
void quakeircd_cmd_pong(char *servname, char *who)
{
    send_cmd(servname, "%s %s", send_token("PONG", "9"), who);
}

/* JOIN - SJOIN */
void quakeircd_cmd_join(char *user, char *channel, time_t chantime)
{
    char *ts = base64enc((long int) chantime);

    send_cmd(ServerName, "%s !%s %s :%s",
             send_token("SJOIN", "~"), ts,
             channel, user);

    if (AutoOp)
        send_cmd(ServerName, "MODE %s +o %s", channel, user);

    denora_free(ts);
}

/* PART */
void quakeircd_cmd_part(char *nick, char *chan, char *buf)
{
    if (buf) {
        send_cmd(nick, "%s %s :%s", send_token("PART", "D"), chan, buf);
    } else {
        send_cmd(nick, "%s %s", send_token("PART", "D"), chan);
    }
}

/* GLOBOPS */
void quakeircd_cmd_global(char *source, char *buf)
{
    send_cmd(source ? source : ServerName, "%s :%s",
             send_token("GLOBOPS", "]"), buf);
}

/* SQUIT */
void quakeircd_cmd_squit(char *servname, char *message)
{
    send_cmd(NULL, "%s %s :%s", send_token("SQUIT", "-"), servname,
             message);
}

/* Events */

int denora_event_ping(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac < 1)
        return MOD_CONT;
    quakeircd_cmd_pong(ac > 1 ? av[1] : ServerName, av[0]);
    return MOD_CONT;
}

void quakeircd_cmd_netinfo(int ac, char **av)
{
    if (ac) {
     send_cmd(NULL, "%s %ld %ld %d %s 0 0 0 :%s",
             send_token("NETINFO", "AO"), (long int) stats->users_max,
             (long int) time(NULL), atoi(av[2]), av[3], av[7]);
    }
}

/* netinfo
 *  argv[0] = max global count
 *  argv[1] = time of end sync
 *  argv[2] = unreal protocol using (numeric)
 *  argv[3] = cloak-crc (> u2302)
 *  argv[4] = free(**)
 *  argv[5] = free(**)
 *  argv[6] = free(**)
 *  argv[7] = ircnet
 */
int denora_event_netinfo(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    quakeircd_cmd_netinfo(ac, av);
    return MOD_CONT;
}


/* TKL
 *           add:      remove:    spamfilter:    spamfilter+TKLEXT  sqline:
 * parv[ 1]: +         -          +/-            +                  +/-
 * parv[ 2]: type      type       type           type               type
 * parv[ 3]: user      user       target         target             hold
 * parv[ 4]: host      host       action         action             host
 * parv[ 5]: setby     removedby  (un)setby      setby              setby
 * parv[ 6]: expire_at            expire_at (0)  expire_at (0)      expire_at
 * parv[ 7]: set_at               set_at         set_at             set_at
 * parv[ 8]: reason               regex          tkl duration       reason
 * parv[ 9]:                                     tkl reason [A]        
 * parv[10]:                                     regex              
 *
*/
int denora_event_tkl(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (!stricmp(av[0], "+")) {
      sql_do_server_bans_add(av[1], av[2], av[3], av[4], av[6], av[5], av[7]);
    }

    if (!stricmp(av[0], "-")) {
      sql_do_server_bans_remove(av[1], av[2], av[3]);
    }
    return MOD_CONT;
}

int denora_event_eos(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    update_sync_state(source, 1);
    return MOD_CONT;
}

int denora_event_436(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac < 1)
        return MOD_CONT;

    m_nickcoll(av[0]);
    return MOD_CONT;
}

/*
** away
**      parv[0] = sender prefix
**      parv[1] = away message
*/
int denora_event_away(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (!ac) {
       m_away(source, NULL);
    } else {
       m_away(source, av[0]);
    }
    return MOD_CONT;
}

/*
** m_topic
**	parv[0] = sender prefix
**	parv[1] = topic text
**
**	For servers using TS: 
**	parv[0] = sender prefix
**	parv[1] = channel name
**	parv[2] = topic nickname
**	parv[3] = topic time
**	parv[4] = topic text
*/
int denora_event_topic(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac != 4)
        return MOD_CONT;
    do_topic(ac, av);
    return MOD_CONT;
}

int denora_event_squit(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac != 2)
        return MOD_CONT;
    do_squit(av[0]);
    return MOD_CONT;
}

int denora_event_quit(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac != 1)
        return MOD_CONT;
    do_quit(source, ac, av);
    return MOD_CONT;
}

int denora_event_mode(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac < 2)
        return MOD_CONT;

    if (*av[0] == '#' || *av[0] == '&') {
        do_cmode(source, ac, av);
    } else {
        do_umode(source, ac, av);
    }
    return MOD_CONT;
}

/* Unreal sends USER modes with this */
/*
    umode2
    parv[0] - sender
    parv[1] - modes to change
*/
int denora_event_umode2(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac < 1)
        return MOD_CONT;

    do_umode2(source, ac, av);
    return MOD_CONT;
}

int denora_event_kill(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac != 2)
        return MOD_CONT;

    m_kill(source, av[0], av[1]);
    return MOD_CONT;
}

int denora_event_kick(char *source, int ac, char **av)
{
    Server *s;
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac != 3) {
        return MOD_CONT;
    }
    if (Numeric) {
      s = findserver_uid(source);
      do_kick((s ? s->name : source), ac, av);
    } else {
        do_kick(source, ac, av);
    }
    return MOD_CONT;
}

int denora_event_join(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac != 1)
        return MOD_CONT;
    do_join(source, ac, av);
    return MOD_CONT;
}

int denora_event_motd(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
  m_motd(source);
  return MOD_CONT;
}

void quakeircd_cmd_motd(char *sender, char *server)
{
    send_cmd(sender, "MOTD %s", server);
}

int denora_event_setname(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    change_user_realname(source, av[0]);
    return MOD_CONT;
}

int denora_event_chgname(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    change_user_realname(av[0], av[1]);
    return MOD_CONT;
}

int denora_event_setident(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    change_user_username(source, av[0]);
    return MOD_CONT;
}

int denora_event_chgident(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    change_user_username(av[0], av[1]);
    return MOD_CONT;
}

int denora_event_sethost(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    change_user_host(source, av[0]);
    return MOD_CONT;
}

/* SVSMODE - forwarded */
int denora_event_svsmode(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (*av[0] != '#') {
        do_svsumode(ac, av);
    } else {
        do_cmode(source, ac, av);
    }
    return MOD_CONT;
}

/*
** NICK - new
**      source  = NULL
**	parv[0] = nickname
**      parv[1] = hopcount
**      parv[2] = timestamp
**      parv[3] = username
**      parv[4] = hostname
**      parv[5] = servername
**  if NICK version 1:
**      parv[6] = servicestamp
**	parv[7] = info
**  if NICK version 2:
**	parv[6] = servicestamp
**      parv[7] = umodes
**	parv[8] = virthost, * if none
**	parv[9] = info
**  if NICKIP:
**      parv[9] = ip
**      parv[10] = info
** 
** NICK - change 
**      source  = oldnick
**	parv[0] = new nickname
**      parv[1] = hopcount
*/
/*
 do_nick(const char *source, char *nick, char *username, char *host,
              char *server, char *realname, time_t ts, uint32 svid,
              uint32 ip, char *vhost, char *uid, int hopcount, char *modes)
*/
int denora_event_nick(char *source, int ac, char **av)
{
    User *user;
    Server *s;
    char buf[BUFSIZE];
    uint32 ts;
    *buf = '\0';

  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }

    if (ac != 2) {
        if (Numeric) {
            snprintf(buf, BUFSIZE - 1, "%ld", base64dec(av[5]));
            s = findserver_uid(buf);
            ts = base64dec_ts(av[2]);
        } else {
            s = findserver(av[5]);
            ts = strtoul(av[2], NULL, 10);
        }
        if (ac == 7) {
            /* 
               <codemastr> that was a bug that is now fixed in 3.2.1
               <codemastr> in  some instances it would use the non-nickv2 format
               <codemastr> it's sent when a nick collision occurs 
               - so we have to leave it around for now -TSL
             */
            do_nick(source, av[0], av[3], av[4], (s ? s->name : av[5]),
                    av[6], ts, 0, 0, NULL, NULL, strtoul(av[1], NULL, 10),
                    NULL);

        } else if (ac == 11) {
            user =
                do_nick(source, av[0], av[3], av[4], (s ? s->name : av[5]),
                        av[10], ts, strtoul(av[6], NULL, 0),
                        ntohl(decode_ip(av[9])), av[8], NULL,
                        strtoul(av[1], NULL, 10), av[7]);

            if (user) {
                denora_set_umode(user, 1, &av[7]);
            }

        } else {
            /* NON NICKIP */
            user =
                do_nick(source, av[0], av[3], av[4], (s ? s->name : av[5]),
                        av[9], ts, strtoul(av[6], NULL, 0), 0, av[8], NULL,
                        strtoul(av[1], NULL, 10), av[7]);

            if (user)
                denora_set_umode(user, 1, &av[7]);
        }
    } else {
        do_nick(source, av[0], NULL, NULL, NULL, NULL,
                strtoul(av[1], NULL, 10), 0, 0, NULL, NULL, 0, NULL);
    }
    return MOD_CONT;
}


int denora_event_chghost(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    change_user_host(av[0], av[1]);
    return MOD_CONT;
}

/* EVENT: SERVER */
int denora_event_server(char *source, int ac, char **av)
{
    char *desc;
    char *vl;
    char *numeric;
    Server *s;

  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }

    if (!stricmp(av[1], "1")) {
        denora->uplink = sstrdup(av[0]);
        me_server->uplink = sstrdup(av[0]);
        vl = myStrGetToken(av[2], ' ', 0);
        numeric = myStrGetToken(vl, '-', 2);
        desc = myStrGetTokenRemainder(av[2], ' ', 1);
        do_server(source, av[0], av[1], desc, numeric);
        denora_free(vl);
        denora_free(desc);
        denora_free(numeric);
    } else {
        if (Numeric) {
            s = findserver_uid(source);
            do_server((s ? s->name : source), av[0], av[1], av[3], av[2]);
        } else {
            do_server(source, av[0], av[1], av[2], NULL);
        }
    }

    return MOD_CONT;
}

int denora_event_privmsg(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac != 2) {
        return MOD_CONT;
    }
    m_privmsg(source, av[0], av[1]);
    return MOD_CONT;
}

int denora_event_part(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac < 1 || ac > 2) {
        return MOD_CONT;
    }
    do_part(source, ac, av);
    return MOD_CONT;
}

int denora_event_whois(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (source && ac >= 1) {
        m_whois(source, av[0]);
    }
    return MOD_CONT;
}

int denora_event_error(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (av[0]) {
        alog(LOG_ERROR, "ERROR: %s", av[0]);
    }
    return MOD_CONT;
}

int denora_event_swhois(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    sql_do_swhois(av[0], av[1]);
    return MOD_CONT;
}

int denora_event_sdesc(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac >= 1) {
      server_set_desc(source, av[0]);
    }
    return MOD_CONT;
}

/*
   On Services connect there is
   SJOIN !11LkOb #ircops +nt :@Trystan &*!*@*.aol.com "*@*.home.com

   av[0] = time stamp (base64)
   av[1] = channel
   av[2] = modes
   av[3] = users + bans + exceptions

   On Channel Creation or a User joins an existing
   Luna.NomadIrc.Net SJOIN !11LkW9 #akill :@Trystan
   Luna.NomadIrc.Net SJOIN !11LkW9 #akill :Trystan`

   av[0] = time stamp (base64)
   av[1] = channel
   av[2] = users

*/
int denora_event_sjoin(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    do_sjoin(source, ac, av);
    return MOD_CONT;
}

void quakeircd_cmd_eob()
{
    send_cmd(ServerName, "%s", send_token("EOS", "ES"));
}

void quakeircd_cmd_ping(char *server)
{
    send_cmd(ServerName, "PING %s :%s", ServerName, server);
}

void quakeircd_cmd_ctcp(char *source, char *dest, char *buf)
{
    send_cmd(source, "%s %s :\1%s \1", send_token("NOTICE", "B"), dest, buf);
}

int denora_event_pong(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
  server_store_pong(source, time(NULL));
  return MOD_CONT;
}

int denora_event_notice(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    if (ac != 2) {
        return MOD_CONT;
    }
    m_notice(source, av[0], av[1]);
    return MOD_CONT;
}

void quakeircd_cmd_connect()
{
    char *hops;

    hops = sstrdup("0");
    if (Numeric) {
        me_server = do_server(NULL, ServerName, hops, ServerDesc, Numeric);
    } else {
        me_server = do_server(NULL, ServerName, hops, ServerDesc, NULL);
    }
    denora_free(hops);

    quakeircd_cmd_capab();
    quakeircd_cmd_pass(RemotePassword);
    quakeircd_cmd_server(ServerName, 1, ServerDesc);
}

/* *INDENT-OFF* */
void moduleAddIRCDMsgs(void) {
    Message *m;

    m = createMessage("AWAY",      denora_event_away); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("6",        denora_event_away); addCoreMessage(IRCD,m);
    }
    m = createMessage("INVITE",    denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("*",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("JOIN",      denora_event_join); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("C",        denora_event_join); addCoreMessage(IRCD,m);
    }
    m = createMessage("KICK",      denora_event_kick); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("H",        denora_event_kick); addCoreMessage(IRCD,m);
    }
    m = createMessage("KILL",      denora_event_kill); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage(".",        denora_event_kill); addCoreMessage(IRCD,m);
    }
    m = createMessage("MODE",      denora_event_mode); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("G",        denora_event_mode); addCoreMessage(IRCD,m);
    }
    m = createMessage("MOTD",      denora_event_motd); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("F",        denora_event_motd); addCoreMessage(IRCD,m);
    }
    m = createMessage("NICK",      denora_event_nick); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("&",        denora_event_nick); addCoreMessage(IRCD,m);
    }
    m = createMessage("NOTICE",    denora_event_notice); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("B",        denora_event_notice); addCoreMessage(IRCD,m);
    }
    m = createMessage("PART",      denora_event_part); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("D",        denora_event_part); addCoreMessage(IRCD,m);
    }
    m = createMessage("PING",      denora_event_ping); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("8",        denora_event_ping); addCoreMessage(IRCD,m);
    }
    m = createMessage("PRIVMSG",   denora_event_privmsg); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("!",        denora_event_privmsg); addCoreMessage(IRCD,m);
    }
    m = createMessage("QUIT",      denora_event_quit); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage(",",        denora_event_quit); addCoreMessage(IRCD,m);
    }
    m = createMessage("SERVER",    denora_event_server); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("'",        denora_event_server); addCoreMessage(IRCD,m);
    }
    m = createMessage("SQUIT",     denora_event_squit); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("-",        denora_event_squit); addCoreMessage(IRCD,m);
    }
    m = createMessage("TOPIC",     denora_event_topic); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage(")",        denora_event_topic); addCoreMessage(IRCD,m);
    }
    m = createMessage("USER",      denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("%",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("WALLOPS",   denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("=",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("WHOIS",     denora_event_whois); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("#",        denora_event_whois); addCoreMessage(IRCD,m);
    }
    m = createMessage("AKILL",     denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("V",       denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("GLOBOPS",   denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("]",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("GNOTICE",   denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("Z",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("GOPER",     denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("[",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("RAKILL",    denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("Y",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("SILENCE",   denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("U",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("SVSKILL",   denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("h",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("SVSMODE",   denora_event_svsmode); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("n",        denora_event_svsmode); addCoreMessage(IRCD,m);
    }
    m = createMessage("SVS2MODE",   denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("v",       denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("SVSNICK",   denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("e",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("SVSNOOP",   denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("f",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("SQLINE",    denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("c",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("UNSQLINE",  denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("d",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("PROTOCTL",  denora_event_capab); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("_",        denora_event_capab); addCoreMessage(IRCD,m);
    }
    m = createMessage("CHGHOST",   denora_event_chghost); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("AL",        denora_event_chghost); addCoreMessage(IRCD,m);
    }
    m = createMessage("CHGIDENT",  denora_event_chgident); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("AZ",        denora_event_chgident); addCoreMessage(IRCD,m);
    }
    m = createMessage("CHGNAME",   denora_event_chgname); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("BK",        denora_event_chgname); addCoreMessage(IRCD,m);
    }
    m = createMessage("NETINFO",   denora_event_netinfo); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("AO",       denora_event_netinfo); addCoreMessage(IRCD,m);
    }
    m = createMessage("SETHOST",   denora_event_sethost); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("AA",        denora_event_sethost); addCoreMessage(IRCD,m);
    }
    m = createMessage("SETIDENT",  denora_event_setident); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("AD",        denora_event_setident); addCoreMessage(IRCD,m);
    }
    m = createMessage("SETNAME",   denora_event_setname); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("AE",        denora_event_setname); addCoreMessage(IRCD,m);
    }
    m = createMessage("TKL", 	   denora_event_tkl); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("BD",       denora_event_tkl); addCoreMessage(IRCD,m);
    }
    m = createMessage("EOS", 	   denora_event_eos); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("ES",       denora_event_eos); addCoreMessage(IRCD,m);
    }
    m = createMessage("PASS", 	   denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("<",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("ERROR", 	   denora_event_error); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("5",        denora_event_error); addCoreMessage(IRCD,m);
    }
    m = createMessage("SMO", 	   denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("AU",       denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("UMODE2",    denora_event_umode2); addCoreMessage(IRCD,m);
    if (UseTokens) {
     m = createMessage("|",        denora_event_umode2); addCoreMessage(IRCD,m);
    }
    m = createMessage("SWHOIS",    denora_event_swhois); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("BA",        denora_event_swhois); addCoreMessage(IRCD,m);
    }
    m = createMessage("SJOIN",      denora_event_sjoin); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("~",        denora_event_sjoin); addCoreMessage(IRCD,m);
    }
    m = createMessage("REHASH",     denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("O",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("ADMIN",      denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("@",        denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("CREDITS",    denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("AJ",       denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("SDESC",      denora_event_sdesc); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("AG",       denora_event_sdesc); addCoreMessage(IRCD,m);
    }
    m = createMessage("HTM",        denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("BH",       denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("HELP",        denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("4",       denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("TRACE",        denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("b",       denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("LAG",        denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("AF",       denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("RPING",        denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("AM",       denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("SENDSNO",    denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("Ss",       denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("SENDUMODE",  denora_event_null); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("AP",       denora_event_null); addCoreMessage(IRCD,m);
    }
    m = createMessage("PONG",       denora_event_pong); addCoreMessage(IRCD,m);
    if (UseTokens) {
      m = createMessage("9",        denora_event_pong); addCoreMessage(IRCD,m);
    }
    /* The none token version of these is in messages.c */
    if (UseTokens) {
     m = createMessage("2",         m_stats); addCoreMessage(IRCD,m);
     m = createMessage(">",         m_time); addCoreMessage(IRCD,m);
     m = createMessage("+",         m_version); addCoreMessage(IRCD,m);
    }
}


/* *INDENT-ON* */

void moduleAddIRCDCmds() {
    pmodule_cmd_nick(quakeircd_cmd_nick);
    pmodule_cmd_mode(quakeircd_cmd_mode);
    pmodule_cmd_bot_nick(quakeircd_cmd_bot_nick);
    pmodule_cmd_notice(quakeircd_cmd_notice);
    pmodule_cmd_privmsg(quakeircd_cmd_privmsg);
    pmodule_cmd_serv_notice(quakeircd_cmd_serv_notice);
    pmodule_cmd_serv_privmsg(quakeircd_cmd_serv_privmsg);
    pmodule_cmd_351(quakeircd_cmd_351);
    pmodule_cmd_quit(quakeircd_cmd_quit);
    pmodule_cmd_pong(quakeircd_cmd_pong);
    pmodule_cmd_join(quakeircd_cmd_join);
    pmodule_cmd_part(quakeircd_cmd_part);
    pmodule_cmd_global(quakeircd_cmd_global);
    pmodule_cmd_squit(quakeircd_cmd_squit);
    pmodule_cmd_connect(quakeircd_cmd_connect);
    pmodule_cmd_eob(quakeircd_cmd_eob);
    pmodule_cmd_ctcp(quakeircd_cmd_ctcp);
    pmodule_cmd_version(quakeircd_cmd_version);
    pmodule_cmd_stats(quakeircd_cmd_stats);
    pmodule_cmd_motd(quakeircd_cmd_motd);
    pmodule_cmd_ping(quakeircd_cmd_ping);
}

int DenoraInit(int argc, char **argv) 
{
  if (denora->protocoldebug) {
        protocol_debug(NULL, argc, argv);
  }

	moduleAddAuthor("Denora");
    moduleAddVersion("$Id: quakeircd.c 433 2005-07-26 16:58:24Z drstein $");
    moduleSetType(PROTOCOL);

    pmodule_ircd_version("QuakeIRCD");
    pmodule_ircd_cap(myIrcdcap);
    pmodule_ircd_var(myIrcd);
    pmodule_ircd_cbmodeinfos(myCbmodeinfos);
    pmodule_ircd_cbmodes(myCbmodes);
    pmodule_ircd_cmmodes(myCmmodes);
    pmodule_ircd_csmodes(myCsmodes);
    pmodule_ircd_umodes(myumodes);
    pmodule_irc_var(IRC_QUAKEIRCD);
    pmodule_ircd_useTSMode(0);

	pmodule_oper_umode(IRC_UMODE_o);

    moduleAddIRCDCmds();
    moduleAddIRCDMsgs();

    return MOD_CONT;
}

