/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: quakeircd.h 427 2005-07-23 08:40:36Z trystan $
 *
 */

/*************************************************************************/

/* User Modes */
#define IRC_UMODE_a 0x00000001  /* a Services Admin */
#define IRC_UMODE_h 0x00000002  /* h Available for help (HelpOp) */
#define IRC_UMODE_i 0x00000004  /* i Invisible (not shown in /who) */
#define IRC_UMODE_o 0x00000008  /* o Global IRC Operator */
#define IRC_UMODE_r 0x00000010  /* r Identifies the nick as being registered  */
#define IRC_UMODE_w 0x00000020  /* w Can listen to wallop messages */
#define IRC_UMODE_A 0x00000040  /* A Server Admin */
#define IRC_UMODE_N 0x00000080  /* N Network Administrator */
#define IRC_UMODE_O 0x00000100  /* O Local IRC Operator */
#define IRC_UMODE_C 0x00000200  /* C Co-Admin */
#define IRC_UMODE_d 0x00000400  /* d Makes it so you can not receive channel PRIVMSGs */
#define IRC_UMODE_p 0x00000800  /* Hides the channels you are in in a /whois reply  */
#define IRC_UMODE_q 0x00001000  /* q Only U:Lines can kick you (Services Admins Only) */
#define IRC_UMODE_s 0x00002000  /* s Can listen to server notices  */
#define IRC_UMODE_t 0x00004000  /* t Says you are using a /vhost  */
#define IRC_UMODE_v 0x00008000  /* v Receives infected DCC Send Rejection notices */
#define IRC_UMODE_z 0x00010000  /* z Indicates that you are an SSL client */
#define IRC_UMODE_B 0x00020000  /* B Marks you as being a Bot */
#define IRC_UMODE_G 0x00040000  /* G Filters out all the bad words per configuration */
#define IRC_UMODE_H 0x00080000  /* H Hide IRCop Status (IRCop Only) */
#define IRC_UMODE_S 0x00100000  /* S services client */
#define IRC_UMODE_V 0x00200000  /* V Marks you as a WebTV user */
#define IRC_UMODE_W 0x00400000  /* W Lets you see when people do a /whois on you */
#define IRC_UMODE_T 0x00800000  /* T Prevents you from receiving CTCPs  */
#define IRC_UMODE_f 0x01000000
#define IRC_UMODE_D 0x10000000
#define IRC_UMODE_g 0x20000000  /* g Can send & read globops and locops */
#define IRC_UMODE_x 0x40000000  /* x Gives user a hidden hostname */
#define IRC_UMODE_R 0x80000000  /* Allows you to only receive PRIVMSGs/NOTICEs from registered (+r) users */
#define IRC_UMODE_I 0x02000000  /* I Ircd Admin */

/*************************************************************************/

/* Channel Modes */

#define IRCD_CMODE_i 0x00000001
#define IRCD_CMODE_m 0x00000002
#define IRCD_CMODE_n 0x00000004
#define IRCD_CMODE_p 0x00000008
#define IRCD_CMODE_s 0x00000010
#define IRCD_CMODE_t 0x00000020
#define IRCD_CMODE_k 0x00000040		/* These two used only by ChanServ */
#define IRCD_CMODE_l 0x00000080
#define IRCD_CMODE_R 0x00000100		/* Only identified users can join */
#define IRCD_CMODE_r 0x00000200		/* Set for all registered channels */
#define IRCD_CMODE_c 0x00000400
#define IRCD_CMODE_A 0x00000800
#define IRCD_CMODE_K 0x00002000
#define IRCD_CMODE_L 0x00004000
#define IRCD_CMODE_O 0x00008000
#define IRCD_CMODE_Q 0x00010000
#define IRCD_CMODE_S 0x00020000
#define IRCD_CMODE_V 0x00040000
#define IRCD_CMODE_f 0x00080000
#define IRCD_CMODE_G 0x00100000
#define IRCD_CMODE_C 0x00200000
#define IRCD_CMODE_u 0x00400000
#define IRCD_CMODE_z 0x00800000
#define IRCD_CMODE_N 0x01000000
#define IRCD_CMODE_T 0x02000000
#define IRCD_CMODE_M 0x04000000
#define IRCD_CMODE_X 0x08000000  /* X */
#define IRCD_CMODE_Y 0x10000000  /* Y */
#define IRCD_CMODE_B 0x20000000

void quakeircd_cmd_nick(char *nick, char *name, const char *modes);
void quakeircd_cmd_mode(char *source, char *dest, char *buf);
void quakeircd_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes);
void quakeircd_cmd_notice(char *source, char *dest, char *buf);
void quakeircd_cmd_privmsg(char *source, char *dest, char *buf);
void quakeircd_cmd_serv_notice(char *source, char *dest, char *msg);
void quakeircd_cmd_serv_privmsg(char *source, char *dest, char *msg);
void quakeircd_cmd_351(char *source);
void quakeircd_cmd_quit(char *source, char *buf);
void quakeircd_cmd_pong(char *servname, char *who);
void quakeircd_cmd_join(char *user, char *channel, time_t chantime);
void quakeircd_cmd_part(char *nick, char *chan, char *buf);
void quakeircd_cmd_global(char *source, char *buf);
void quakeircd_cmd_squit(char *servname, char *message);
void quakeircd_cmd_connect(void);
void quakeircd_cmd_eob(void);
void quakeircd_cmd_capab(void);
void quakeircd_cmd_ctcp(char *source, char *dest, char *buf);
void quakeircd_cmd_stats(char *sender, const char *letter, char *server);
void quakeircd_cmd_motd(char *sender, char *servr);
void quakeircd_cmd_ping(char *server);
void quakeircd_cmd_pass(char *pass);
void quakeircd_cmd_server(char *servname, int hop, char *descript);
void quakeircd_cmd_netinfo(int ac, char **av);
void quakeircd_cmd_version(char *server);

int denora_event_436(char *source, int ac, char **av);
int denora_event_away(char *source, int ac, char **av);
int denora_event_ping(char *source, int ac, char **av);
int denora_event_motd(char *source, int ac, char **av);
int denora_event_join(char *source, int ac, char **av);
int denora_event_kick(char *source, int ac, char **av);
int denora_event_kill(char *source, int ac, char **av);
int denora_event_mode(char *source, int ac, char **av);
int denora_event_quit(char *source, int ac, char **av);
int denora_event_squit(char *source, int ac, char **av);
int denora_event_topic(char *source, int ac, char **av);
int denora_event_whois(char *source, int ac, char **av);
int denora_event_part(char *source, int ac, char **av);
int denora_event_server(char *source, int ac, char **av);
int denora_event_nick(char *source, int ac, char **av);
int denora_event_gnotice(char *source, int ac, char **av);
int denora_event_privmsg(char *source, int ac, char **av);
int denora_event_capab(char *source, int ac, char **av);
int denora_event_sjoin(char *source, int ac, char **av);
int denora_event_svinfo(char *source, int ac, char **av);
int denora_event_chghost(char *source, int ac, char **av);
int denora_event_sethost(char *source, int ac, char **av);
int denora_event_chgident(char *source, int ac, char **av);
int denora_event_setident(char *source, int ac, char **av);
int denora_event_chgname(char *source, int ac, char **av);
int denora_event_setname(char *source, int ac, char **av);
int denora_event_svsinfo(char *source, int ac, char **av);
int denora_event_snick(char *source, int ac, char **av);
int denora_event_vhost(char *source, int ac, char **av);
int denora_event_tkl(char *source, int ac, char **av);
int denora_event_eos(char *source, int ac, char **av);
int denora_event_eob(char *source, int ac, char **av);
int denora_event_pass(char *source, int ac, char **av);
int denora_event_netinfo(char *source, int ac, char **av);
int denora_event_error(char *source, int ac, char **av);
int denora_event_netctrl(char *source, int ac, char **av);
int denora_event_notice(char *source, int ac, char **av);
int denora_event_snotice(char *source, int ac, char **av);
int denora_event_sqline(char *source, int ac, char **av);
int denora_event_umode2(char *source, int ac, char **av);
int denora_event_globops(char *source, int ac, char **av);
int denora_event_swhois(char *source, int ac, char **av);
int denora_event_burst(char *source, int ac, char **av);
int denora_event_sdesc(char *source, int ac, char **av);
int denora_event_svsmode(char *source, int ac, char **av);
int denora_event_sgline(char *source, int ac, char **av);
int denora_event_pong(char *source, int ac, char **av);

int DenoraInit(int argc, char **argv);
void moduleAddIRCDMsgs(void);
void moduleAddIRCDCmds(void);
void DenoraFini(void);
