/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: viagra.h 427 2005-07-23 08:40:36Z trystan $
 *
 */

/* User Modes */
#define IRC_UMODE_A 0x00000040  /* Is a Server Administrator. */
#define IRC_UMODE_C 0x00002000  /* Is a Server Co Administrator. */
#define IRC_UMODE_I 0x00008000  /* Stealth mode, makes you beeing hidden at channel. invisible joins/parts. */
#define IRC_UMODE_N	0x00000400  /* Is a Network Administrator. */
#define IRC_UMODE_O 0x00004000  /* Local IRC Operator. */
#define IRC_UMODE_Q 0x00001000  /* Is an Abuse Administrator. */
#define IRC_UMODE_R 0x08000000  /* Cant receive messages from non registered user. */
#define IRC_UMODE_S	0x00000080  /* Is a Network Service. For Services only. */
#define IRC_UMODE_T	0x00000800  /* Is a Technical Administrator. */
#define IRC_UMODE_a 0x00000001  /* Is a Services Administrator. */
#define IRC_UMODE_b 0x00040000  /* Can listen to generic bot warnings. */
#define IRC_UMODE_c 0x00010000  /* See's all connects/disconnects on local server. */
#define IRC_UMODE_d	0x00000100  /* Can listen to debug and channel cration notices. */
#define IRC_UMODE_e 0x00080000  /* Can see client connections/exits on remote servers. */
#define IRC_UMODE_f 0x00100000  /* Listen to flood/spam alerts from server. */
#define IRC_UMODE_g	0x00000200  /* Can read & send to globops, and locops. */
#define IRC_UMODE_h 0x00000002  /* Is a Help Operator. */
#define IRC_UMODE_i 0x00000004  /* Invisible (Not shown in /who and /names searches). */
#define IRC_UMODE_n 0x00020000  /* Can see client nick change notices. */
#define IRC_UMODE_o 0x00000008  /* Global IRC Operator. */
#define IRC_UMODE_r 0x00000010  /* Identifies the nick as being registered. */
#define IRC_UMODE_s 0x00200000  /* Can listen to generic server messages. */
#define IRC_UMODE_w 0x00000020  /* Can listen to wallop messages. */
#define IRC_UMODE_x 0x40000000  /* Gives the user hidden hostname. */

/* Channel Modes */
#define IRCD_CMODE_i 0x00000001  /* Invite-only allowed. */
#define IRCD_CMODE_m 0x00000002  /* Moderated channel, noone can speak and changing nick except users with mode +vho */
#define IRCD_CMODE_n 0x00000004  /* No messages from outside channel */
#define IRCD_CMODE_p 0x00000008  /* Private channel. */
#define IRCD_CMODE_s 0x00000010  /* Secret channel. */
#define IRCD_CMODE_t 0x00000020  /* Only channel operators may set the topic */
#define IRCD_CMODE_k 0x00000040  /* Needs the channel key to join the channel */
#define IRCD_CMODE_l 0x00000080  /* Channel may hold at most <number> of users */
#define IRCD_CMODE_R 0x00000100  /* Requires a registered nickname to join the channel. */
#define IRCD_CMODE_r 0x00000200  /* Channel is registered. */
#define IRCD_CMODE_c 0x00000400  /* No ANSI color can be sent to the channel */
#define IRCD_CMODE_M 0x00000800  /* Requires a registered nickname to speak at the channel. */
#define IRCD_CMODE_H 0x00001000  /* HelpOps only channel. */
#define IRCD_CMODE_O 0x00008000  /* IRCOps only channel. */
#define IRCD_CMODE_S 0x00020000  /* Strips all mesages out of colors. */
#define IRCD_CMODE_N 0x01000000  /* No nickchanges allowed. */
#define IRCD_CMODE_P 0x02000000  /* "Peace mode" No kicks allowed unless by u:lines */
#define IRCD_CMODE_x 0x04000000  /* No bold/underlined or reversed text can be sent to the channel */

void viagra_cmd_nick(char *nick, char *name, const  char *modes);
void viagra_cmd_mode(char *source, char *dest, char *buf);
void viagra_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes);
void viagra_cmd_notice(char *source, char *dest, char *buf);
void viagra_cmd_privmsg(char *source, char *dest, char *buf);
void viagra_cmd_serv_notice(char *source, char *dest, char *msg);
void viagra_cmd_serv_privmsg(char *source, char *dest, char *msg);
void viagra_cmd_351(char *source);
void viagra_cmd_quit(char *source, char *buf);
void viagra_cmd_pong(char *servname, char *who);
void viagra_cmd_join(char *user, char *channel, time_t chantime);
void viagra_cmd_part(char *nick, char *chan, char *buf);
void viagra_cmd_global(char *source, char *buf);
void viagra_cmd_squit(char *servname, char *message);
void viagra_cmd_connect(void);
void viagra_cmd_eob(void);
void viagra_cmd_ctcp(char *source, char *dest, char *buf);
void viagra_cmd_version(char *server);
void viagra_cmd_stats(char *sender, const char *letter, char *server);
void viagra_cmd_motd(char *sender, char *servr);
void viagra_cmd_ping(char *server);
void viagra_cmd_pass(char *pass);
void viagra_cmd_server(char *servname, int hop, char *descript);
void viagra_cmd_svinfo(void);
void viagra_cmd_capab(void);
void viagra_cmd_burst(void);

int denora_event_436(char *source, int ac, char **av);
int denora_event_away(char *source, int ac, char **av);
int denora_event_ping(char *source, int ac, char **av);
int denora_event_motd(char *source, int ac, char **av);
int denora_event_join(char *source, int ac, char **av);
int denora_event_kick(char *source, int ac, char **av);
int denora_event_kill(char *source, int ac, char **av);
int denora_event_mode(char *source, int ac, char **av);
int denora_event_quit(char *source, int ac, char **av);
int denora_event_squit(char *source, int ac, char **av);
int denora_event_topic(char *source, int ac, char **av);
int denora_event_whois(char *source, int ac, char **av);
int denora_event_part(char *source, int ac, char **av);
int denora_event_server(char *source, int ac, char **av);
int denora_event_nick(char *source, int ac, char **av);
int denora_event_privmsg(char *source, int ac, char **av);
int denora_event_capab(char *source, int ac, char **av);
int denora_event_sjoin(char *source, int ac, char **av);
int denora_event_chghost(char *source, int ac, char **av);
int denora_event_sethost(char *source, int ac, char **av);
int denora_event_chgident(char *source, int ac, char **av);
int denora_event_setident(char *source, int ac, char **av);
int denora_event_chgname(char *source, int ac, char **av);
int denora_event_setname(char *source, int ac, char **av);
int denora_event_error(char *source, int ac, char **av);
int denora_event_notice(char *source, int ac, char **av);
int denora_event_burst(char *source, int ac, char **av);
int denora_event_pong(char *source, int ac, char **av);

int DenoraInit(int argc, char **argv);
void moduleAddIRCDMsgs(void);
void moduleAddIRCDCmds(void);
void DenoraFini(void);

